import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { MatchOrder, MatchOrderParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询比赛报名记录表
 */
export async function pageMatchOrder(params: MatchOrderParam) {
  const res = await request.get<ApiResult<PageResult<MatchOrder>>>(
    MODULES_API_URL + '/booking/match-order/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询比赛报名记录表列表
 */
export async function listMatchOrder(params?: MatchOrderParam) {
  const res = await request.get<ApiResult<MatchOrder[]>>(
    MODULES_API_URL + '/booking/match-order',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加比赛报名记录表
 */
export async function addMatchOrder(data: MatchOrder) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/match-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改比赛报名记录表
 */
export async function updateMatchOrder(data: MatchOrder) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/match-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除比赛报名记录表
 */
export async function removeMatchOrder(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/match-order/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除比赛报名记录表
 */
export async function removeBatchMatchOrder(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/match-order/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询比赛报名记录表
 */
export async function getMatchOrder(id: number) {
  const res = await request.get<ApiResult<MatchOrder>>(
    MODULES_API_URL + '/booking/match-order/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
